
#include <stdio.h>
#include <time.h>

#define BUFSIZE 128

main() {

    FILE *fp1,*fp2,*fopen();

    float x[BUFSIZE];
    time_t start,stop;
    float bps;
    double difftime();
    int tb = 0;

    int i,j;

    fp2 = fopen("random.numbers","w");
    if (fp2 == NULL) {
	printf("failed to open random.numbers\n");
	exit(0);
    }
    for (i=1; i<=100; i++) {
	if (i == 20) {
	    time(&start);
	    tb = 0;
	}
	for (j=0; j<BUFSIZE; j++) {
	    x[j] = (float) rand();
	}
	fwrite(x,BUFSIZE*sizeof(float),1,fp2);
	if (ferror(fp2)) {
	    printf("Error reading tape\n");
	    exit(0);
	}
        tb += BUFSIZE*sizeof(float);
    }
    time(&stop);
    bps = (float) difftime(stop,start);
    bps = ((float) tb) / bps;
    printf("%d bytes transferred, %f bytes/second\n",tb,bps);
    fflush(stdout);
    fclose(fp2);
    exit(0);
}
