#include "Barnacle.hxx"
#include <string.h>
#include <iostream.h>

BarnacleList::~BarnacleList() {
 dlist_iterator getNext( theList );
 Barnacle* p;
 while( p = (Barnacle*) getNext() ) delete p;
}
 
void BarnacleList::append( const Barnacle* x ) {
 theList.append( (ent) x );
}


void BarnacleList::insert( const Barnacle* x ) {
 theList.insert( (ent) x );
}


void BarnacleList::append( const char* ident, const BarnacleData* w ) {
 theList.append( (ent) new Barnacle( ident, w ) );
}


void BarnacleList::insert( const char* ident, const BarnacleData* w ) {
 theList.insert( (ent) new Barnacle( ident, w ) );
}


char BarnacleList::eraseFirst( const char* ident ) {
 dlist_iterator getNext( theList );
 Barnacle* p;
 while( p = (Barnacle*) getNext() ) {
  if( strcmp( ident, p->id ) == 0 ) {
   theList.remove( (ent) p );   // ??? This is REALLY stupid!
   delete p;
   return 0;   // All OK
  }
 }
 return 1;     // Not OK
}


char BarnacleList::eraseAll( const char* ident ) {
 dlist_iterator getNext( theList );
 Barnacle* p;
 if( ident ) {
  while( p = (Barnacle*) getNext() ) {
   if( strcmp( ident, p->id ) == 0 ) {
    theList.remove( (ent) p );   // ??? This is REALLY stupid!
    delete p;
   }
  }
 }
 else {
  while( p = (Barnacle*) getNext() ) {
   theList.remove( (ent) p );   // ??? This is REALLY stupid!
   delete p;
  }
 }
 return 0;
}


BarnacleData* BarnacleList::find( const char* ident ) {
 dlist_iterator getNext( theList );
 Barnacle* p;
 while( p = (Barnacle*) getNext() ) 
  if( strcmp( ident, p->id ) == 0 ) return p->info;
 return 0;
}

Barnacle* BarnacleList::lift( const char* ident ) {
 dlist_iterator getNext( theList );
 Barnacle* p;
 while( p = (Barnacle*) getNext() ) 
  if( strcmp( ident, p->id ) == 0 ) {
   theList.remove( (ent) p );   // ??? This is REALLY stupid!
   return p;
  }
 return 0;
}

Barnacle::Barnacle( const char* s, const BarnacleData* e ) {
 id = new char[ strlen(s) + 1 ];
 strcpy( id, s );
 info = (BarnacleData*) e;
}

Barnacle::~Barnacle() {
 delete [] id;
 delete info;
}
