/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/


#include <acp_user.h>

#define MAX_EVENTS 4000000
#define EVENT_SIZE 128
#define OUT_SIZE 128

/* Process classes */

#define INPUT 1
#define SORT 2
#define OUTPUT 3

/* Process queues */

#define READY_QUEUE 1
#define DONE_QUEUE 2

/* Synch points */

#define BEGIN_SYNC 0
#define END_SYNC 1

/* Remote subroutines */

#define SORT_REMSUB 1

/* Data blocks */

#define IN_BLOCK 1
#define OUT_BLOCK 2
