/*
**
** Test of LieOperator::inverse() 
** This does not work well because of retaining
** negligible terms (of order 10**-16).  I do
** not yet understand why these terms are being
** kept.
** 
** --- Leo Michelotti
** --- September 15, 1993
**
*/

#include <stdlib.h>
#include <stdio.h>
#include "mxyzptlk.rsc"

main( ) {
 
 Jet::Setup( 3, 4, 3 );

 coord        x(0.0), y(0.0), z(0.0);
 LieOperator  w;
 LieOperator  u;

 w.setVariable( x + 3.0*y + x*y - y*z,   0 );
 w.setVariable( y - x + z + x*z + y*y,   1 );
 w.setVariable( z + 2.0*x + y*z - x*y*z, 2 );

 u = w.Inverse();

 printf( "\n====== w.printCoeffs(); =================\n" );
 w.printCoeffs();

 printf( "\n====== u.printCoeffs(); =================\n" );
 u.printCoeffs();

 printf( "\n====== w(u).printCoeffs(); =================\n" );
 w(u).printCoeffs();

 printf( "\n====== u(w).printCoeffs(); =================\n" );
 u(w).printCoeffs();
}
