#include "mxyzptlk.rsc"

//***************************************************************
//***************************************************************
//***************************************************************
// 
//
//	Test program.
//

main() {

Jet::setup( 3, 7 );

coord x( 0.5 );
coord y( 0.3 );
coord z( 0.1 );
Jet h, u, v;

static double r[]  = { 1.0,  0.0,  0.0 };
static double s[]  = { 0.33, 0.33, 0.33 };
static int index[] = { 2, 1, 3 };

// First test ....
h = 1.0 / ( cos( exp( x*x*y - 3.0*x*z*z ) ) );
printf( "First test\nThe derivative is: %lf, = %lf\n\n",  
        h.derivative( index ),
        (1.0 / ( cos( exp( x*x*y - 3.0*x*z*z ) ) )).derivative( index ) 
      );

// Second test ....
u = exp( x );
v = exp( x + y + z );

printf( "The correct result is: %lf\n\n", exp( 1.0 ) );
s[2] = 1.0 - s[0] - s[1];
for( int w = 1; w <= 7; w++ ) {
  printf(
          "%d: %lf   %lf  \n", 
          w, 
          (u.filter( 0, w ))( r ),
          (v.filter( 0, w ))( s ) 
        );
//   cout << w << ":   " << (u.filter( 0, w ))( r ) 
//             << "    " << (v.filter( 0, w ))( s ) 
//             << "\n";
  }
}
