#ifndef BARNACLE_HXX
#define BARNACLE_HXX

#include "dlist.hxx"

struct BarnacleData {
 BarnacleData() {};
 virtual ~BarnacleData() {};
};

class Barnacle {
private:
 char* id;
 friend class BarnacleList;
public:
 Barnacle( const char*         /* identifier tag  */,
           const BarnacleData* /* the information */ );
 ~Barnacle();
 BarnacleData* info;
};

class BarnacleList {
public:
 BarnacleList() {}
 ~BarnacleList();
 void            append    ( const Barnacle* );
 void            insert    ( const Barnacle* );
 void            append    ( const char*, const BarnacleData* );
 void            insert    ( const char*, const BarnacleData* );
 char            eraseFirst( const char*     /* identifier */ );
 char            eraseAll  ( const char* = 0 /* identifier */ );
 BarnacleData*   find      ( const char*     /* identifier */ );
 Barnacle*       lift      ( const char*     /* identifier */ );
private:
 dlist theList;
};

#endif // BARNACLE_HXX
